StringCollectionDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser.std

## Class StringCollectionDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<T>
  - - org.codehaus.jackson.map.deser.std.StdDeserializer<T>
    - - org.codehaus.jackson.map.deser.std.ContainerDeserializerBase<Collection<String>>
      - - org.codehaus.jackson.map.deser.std.StringCollectionDeserializer

- All Implemented Interfaces:
    ResolvableDeserializer

      public final class StringCollectionDeserializer
      extends ContainerDeserializerBase<Collection<String>>
      implements ResolvableDeserializer

  Since:
    1.9 (moved from higher-level package)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `StdDeserializer.BigDecimalDeserializer, StdDeserializer.BigIntegerDeserializer, StdDeserializer.BooleanDeserializer, StdDeserializer.ByteDeserializer, StdDeserializer.CharacterDeserializer, StdDeserializer.DoubleDeserializer, StdDeserializer.FloatDeserializer, StdDeserializer.IntegerDeserializer, StdDeserializer.LongDeserializer, StdDeserializer.NumberDeserializer, StdDeserializer.PrimitiveOrWrapperDeserializer<T>, StdDeserializer.ShortDeserializer, StdDeserializer.SqlDateDeserializer, StdDeserializer.StackTraceElementDeserializer`

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_collectionType`
    `protected JsonDeserializer<Object>` | `_delegateDeserializer` Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.
    `protected boolean` | `_isDefaultDeserializer` Flag that indicates whether value deserializer is the standard Jackson-provided one; if it is, we can use more efficient handling.
    `protected JsonDeserializer<String>` | `_valueDeserializer` Value deserializer; needed even if it is the standard String deserializer
    `protected ValueInstantiator` | `_valueInstantiator`

    - ### Fields inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `StringCollectionDeserializer(JavaType collectionType, JsonDeserializer<?> valueDeser, ValueInstantiator valueInstantiator)`
    `protected` | `StringCollectionDeserializer(StringCollectionDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Collection<String>` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `Collection<String>` | `deserialize(JsonParser jp, DeserializationContext ctxt, Collection<String> result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
    `void` | `resolve(DeserializationConfig config, DeserializerProvider provider)` Method called to finalize setup of this deserializer, after deserializer itself has been registered.

    - ### Methods inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultSerializer, parseDouble, reportUnknownProperty`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonDeserializer

      `getEmptyValue, getNullValue, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _collectionType

          protected final JavaType _collectionType

    - #### _valueDeserializer

          protected final JsonDeserializer<String> _valueDeserializer

      Value deserializer; needed even if it is the standard String deserializer

    - #### _isDefaultDeserializer

          protected final boolean _isDefaultDeserializer

      Flag that indicates whether value deserializer is the standard Jackson-provided one; if it is, we can use more efficient handling.

    - #### _valueInstantiator

          protected final ValueInstantiator _valueInstantiator

      Since:
        1.9

    - #### _delegateDeserializer

          protected JsonDeserializer<Object> _delegateDeserializer

      Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.

  - ### Constructor Detail

    - #### StringCollectionDeserializer

          public StringCollectionDeserializer(JavaType collectionType,
                                      JsonDeserializer<?> valueDeser,
                                      ValueInstantiator valueInstantiator)

    - #### StringCollectionDeserializer

          protected StringCollectionDeserializer(StringCollectionDeserializer src)

      Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
      Since:
        1.9

  - ### Method Detail

    - #### resolve

          public void resolve(DeserializationConfig config,
                     DeserializerProvider provider)
                       throws JsonMappingException

      Method called to finalize setup of this deserializer, after deserializer itself has been registered. This is needed to handle recursive and transitive dependencies.
      Specified by:
        `resolve` in interface `ResolvableDeserializer`
        `provider` - Provider that has constructed deserializer this method is called on.
      Throws:
        `JsonMappingException`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerDeserializerBase`
      Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
      Specified by:
        `getContentType` in class `ContainerDeserializerBase<Collection<String>>`

    - #### getContentDeserializer

          public JsonDeserializer<Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<Collection<String>>`

    - #### deserialize

          public Collection<String> deserialize(JsonParser jp,
                                       DeserializationContext ctxt)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Collection<String>>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserialize

          public Collection<String> deserialize(JsonParser jp,
                                       DeserializationContext ctxt,
                                       Collection<String> result)
                                         throws IOException,
                                                JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used for all supported types; most commonly it is used for Collections and Maps.

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not expect to get the call.

      Overrides:
        `deserialize` in class `JsonDeserializer<Collection<String>>`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser jp,
                                   DeserializationContext ctxt,
                                   TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<Collection<String>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`